open Avl_defs

let create () = empty

let rec add k v m =
  match m with
  | Empty -> bal empty k v empty
  | Node(fg, k', v', fd, _) ->
     if k < k'
     then bal (add k v fg) k' v' fd
     else if k > k'
     then bal fg k' v' (add k v fd)
     else bal fg k v fd
     
let rec find k m =
  match m with
  | Empty -> raise Not_found
  | Node(fg, k', v', fd, _) ->
     if k < k'
     then find k fg
     else if k > k'
     then find k fd
     else v'


let rec remove_rightmost m =
  match m with
    Empty -> assert false
  | Node(fg, k, v, Empty, _) -> fg, k, v
  | Node(fg, k, v, fd, _) ->
     let fd', k', v' = remove_rightmost fd in
     bal fg k v fd', k', v'
       
let remove_root m =
  match m with
    Empty -> assert false
  | Node(Empty, _, _, fd,_) -> fd
  | Node(fg, _, _, Empty,_) -> fg
  | Node(fg, _, _, fd,_) ->
     let fg', k, v = remove_rightmost fg in
     bal fg' k v fd
     
     
       
let rec remove k m =
  match m with
  | Empty -> empty
  | Node(fg, k', v', fd, _) ->
     if k < k'
     then bal (remove k fg) k' v' fd
     else if k > k'
     then bal fg k' v' (remove k fd)
     else remove_root m
