type ('k, 'v) map =
    Empty
  | Node of ('k, 'v) map * 'k * 'v * ('k, 'v) map * int

let hauteur m =
  match m with
    Empty -> 0
  | Node (_,_,_,_,h) -> h
      
let node fg k v fd =
  let hg = hauteur fg in
  let hd = hauteur fd in
  Node(fg, k, v, fd, max hg hd + 1)

let rotation_droite m =
  match m with
  | Node(Node(u, kp, vp, v, _), kq, vq, w, _) ->
     node u kp vp (node v kq vq w)
  | _ -> assert false

let rotation_gauche m =
  match m with
  | Node(u, kp, vp, Node(v, kq, vq, w, _), _) ->
     node (node u kp vp v) kq vq w
  | _ -> assert false
     
let bal fg k v fd =
  let hg = hauteur fg in
  let hd = hauteur fd in
  if hg = hd + 2
  then match fg with
  | Node(l, kp, vp, r, _) ->
     let hl = hauteur l in
     let hr = hauteur r in
     if hl >= hr then rotation_droite (node fg k v fd)
     else
       let fg' = rotation_gauche fg in
       rotation_droite (node fg' k v fd)
  | Empty -> assert false
  else if hd = hg + 2
  then match fd with
  | Node(l, kp, vp, r, _) ->
     let hl = hauteur l in
     let hr = hauteur r in
     if hl <= hr then rotation_gauche (node fg k v fd)
     else
       let fd' = rotation_droite fd in
       rotation_gauche (node fg k v fd')
  | Empty -> assert false
  else node fg k v fd

let empty = Empty
